import { buildUUID } from '../../../../utils/uuid';
//import { ApiAction, ApiActionPage } from '../../model/baseModel';
import { genAction, Api } from '../../system';
import { useUserStore } from '/@/store/modules/user';
import { defHttp } from '/@/utils/http/axios';
import { isNullOrEmpty } from '/@/utils/is';
import { formatToDateTime } from '/@/utils/dateUtil';

/*
 * 获取锡膏胶水信息
 */

export const getsolderListByPage = async (params: any) => {
  let order = ''
  if (params.order != undefined) {
    order = params.order == 'descend' ? (params.field + ' desc') : params.field
  }
  let sqlcmd = '1=1';
  if (params?.UPN != undefined && params?.UPN != '') {
    sqlcmd += " And UPN like '%" + params?.UPN + "%'";
  }

  let option ={
    UserId:useUserStore().getUserInfo.userId as string,
    ByOrg:true,
    OrgCode:useUserStore().getUserInfo.orgCode as string
  }
  if (!isNullOrEmpty(params.page)) {
    const usParams = genAction('SMT_SOLDER', {
      QueryAble_T: '',
      where: sqlcmd,
      order: order,
      page: {
        pageAble_T: 'string',
        draw: 1,
        pageIndex: params.page,
        pageSize: params.pageSize,
      }
    });
    return getFinishedwarehouseListByPageAsync(usParams);
  } else {
    const usParams = genAction('SMT_SOLDER', {
      QueryAble_T: '',
      where: sqlcmd,
      option
    },option);
    return getFinishedwarehouseListByPageAsync(usParams);
  }
  // const rParams = genActionPage('BIZ_ERP_PROD_IN', sqlcmd, params.page, params.pageSize,option);
  // return getFinishedwarehouseListByPageAsync(rParams);
};
async function getFinishedwarehouseListByPageAsync(params: any) {
  const data = await defHttp.post(
    { url: Api.QueryUrl, params },
    {
      isTransformResponse: false,
    },
  );
  const model = {
    items: data.Data.page.data,
    total: data.Data.page.totals,
  };
  return model;
}
//新增锡膏胶水信息
export const SaveSolder = async (params: Recordable, isUpdate: boolean) => {
  const Solderitem: any = {
    ID: params.ID,
    CREATE_TIME: params?.CREATE_TIME,
    CREATE_USER: params?.CREATE_USER,
    UPDATE_TIME: params?.UPDATE_TIME,
    UPDATE_USER: params?.UPDATE_USER,
    GHOST_ROW: params?.GHOST_ROW,
    AUTH_ORG: params?.AUTH_ORG,
    AUTH_PROD: params?.AUTH_PROD,
    AUTH_WH: params?.AUTH_WH,
    UPN: params.UPN,
    CPN: params.CPN,
    TYPE: params.TYPE,
    STATUS: params?.STATUS,
    EXP_DATE: params.EXP_DATE,
    LINE_CODE: params?.LINE_CODE,
    IS_OUT: params?.IS_OUT,
    OUT_DATE: params?.OUT_DATE,
    OUT_USER: params?.OUT_USER,
    IS_SEND: params?.IS_SEND,
    SEND_DATE: params?.SEND_DATE,
    SEND_USER: params?.SEND_USER,
    IS_OPEN: params?.IS_OPEN,
    OPEN_DATE: params?.OPEN_DATE,
    OPEN_USER: params?.OPEN_USER,
    FIRST_DATE: params?.FIRST_DATE,
    FIRST_USER: params?.FIRST_USER,
    STIR_SEQ: params?.STIR_SEQ,
    STIR_DATE: params?.STIR_DATE,
    STIR_USER: params?.STIR_USER,
    REFREEZE_SEQ: params?.REFREEZE_SEQ,
    REFREEZE_DATE: params?.REFREEZE_DATE,
    REFREEZE_USER: params?.REFREEZE_USER,
    REMARK: params?.REMARK,

  };
  let data;

  if (isUpdate) {
    Solderitem.STATUS=6;
    const time = new Date();
    Solderitem.UPDATE_TIME = formatToDateTime(time);
    Solderitem.UPDATE_USER = useUserStore().getUserInfo.userId as string;
    // regionitem.ORG_CODE = useUserStore().getUserInfo.orgCode as string;
    // regionitem.AUTH_ORG = useUserStore().getUserInfo.orgCode as string;
    data = await defHttp.post(
      { url: Api.UpdateEntity, params: genAction('SMT_SOLDER', Solderitem) },
      {
        errorMessageMode: 'none',
        isTransformResponse: false,
      },
    );
  } else {
    // const usParams = genAction(
    //   'SMT_SOLDER',
    //   "REGION_CODE='" + params.REGION_CODE + "'AND AUTH_ORG='" + regionitem.ORG_CODE + "'",
    // );
    //var check = await isExist(usParams);
    //console.log('check',check)
    //if (!check.Data) {
      Solderitem.ID = buildUUID(); //生成GUID
      Solderitem.UPDATE_TIME = formatToDateTime(new Date());
      Solderitem.CREATE_USER = useUserStore().getUserInfo.userId as string;
      Solderitem.UPDATE_USER = useUserStore().getUserInfo.userId as string;
      // regionitem.ORG_CODE = useUserStore().getUserInfo.orgCode as string;
      // regionitem.AUTH_ORG = useUserStore().getUserInfo.orgCode as string;
      data = await defHttp.post(
        { url: Api.AddEntity, params: genAction('SMT_SOLDER', Solderitem) },
        {
          errorMessageMode: 'none',
          isTransformResponse: false,
        },
      );
    //} else {
      // return check.Message;
      //return '重复了';
    //}
  }
  return data;
};
//下拉列表
// STATUSs 单据状态
export const optionsListApi = async (params: Recordable) => {
  const usParams = genAction('SMT_SOLDER+STATUSs', '');
  return await defHttp.post(
    { url: Api.urlQueryEnum, params: usParams },
    {
      errorMessageMode: 'none',
      isTransformResponse: false,
      // apiUrl: globSetting.taskApiUrl
    },
  );
};